#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# qmsg: defines the layout and functions of the send message to jobs dialog
# 	box.
proc qmsg {} {
  global jobsSelected LABELFONT SERVER_HOSTS cmdpath qmsgDialogBox \
	 qmsgv activeWindow

  busy_cursor
## Bring up the standard Dialog box ##
  set qmsgDialogBox ".msg"
  set dbox [popupDialogBox $qmsgDialogBox "Send Message to Running Job Dialog"]
  set activeWindow($qmsgDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{{msg "Send Message"} {cancel cancel} {help help}}} x 5m 13 3]

  set cmdFrame  [lindex $cmdButtons 0]
  set cmdMsg    [lindex $cmdButtons 1]
  set cmdCancel [lindex $cmdButtons 2]
  set cmdHelp   [lindex $cmdButtons 3]
 
  $cmdMsg configure -command {

    update idletasks

    if {[string compare $qmsgv(msg) ""] == 0} {
      popupInfoBox $qmsgDialogBox "Please specify the message to send."
      return
    }
    if {[string compare $qmsgv(stdout) ""] == 0 && \
        [string compare $qmsgv(stderr) ""] == 0} {
      set qmsgv(stderr) "-E"
      update idletasks
    }
    set exitcode [win_cmdExec $qmsgDialogBox "$cmdpath(QMSG) $qmsgv(stdout) $qmsgv(stderr) \"$qmsgv(msg)\" $jobsSelected"]


    if {$exitcode == 0} {
      after 500 [list getdata $SERVER_HOSTS 1]
      destroy $qmsgDialogBox
    }
  }
  $cmdCancel configure -command [list destroy $qmsgDialogBox]

  $cmdHelp configure -command {xpbs_help message $qmsgDialogBox}

## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m
  frame $dbox_top.j1
  frame $dbox_top.m1
  frame $dbox_top.r
  frame $dbox_top.empty1 -width 14m

## Create the job id box

  set jobid [buildFullListbox $dbox_top.j1 40x3 "" xyscroll 0]
  set jobidFrame    [lindex $jobid 0]
  set jobidBox      [lindex $jobid 3]
  bind_text_readonly $jobidBox

  foreach el $jobsSelected {
    $jobidBox insert end $el
  }

## Create the Send Message entry
  set msgbox [buildFullEntrybox $dbox_top.m1 13 "Send message:" 60 \
				  "" bottom 0]
  set msgFrame [lindex $msgbox 0]
  set msgField [lindex $msgbox 2]
  $msgField configure -textvariable qmsgv(msg)
  register_default_action $msgField $cmdCancel

  set checkbox [buildCheckboxes $dbox_top.r  \
                   {{ {standout "Stdout"}   \
		      {standerr "Stderr"}   \
	           }} column 0]
  set checkboxFrame  [lindex $checkbox 0]
  set checkboxStdout [lindex $checkbox 1]
  set checkboxStderr [lindex $checkbox 2]

  $checkboxStdout configure -variable qmsgv(stdout) -onvalue "-O" -offvalue ""
  $checkboxStderr configure -variable qmsgv(stderr) -onvalue "-E" -offvalue ""

  set qmsgv(stdout) ""
  set qmsgv(stderr) "-E"
   

  label $dbox_top.checkboxLabel1 -text "to" -font $LABELFONT
  label $dbox_top.label2 -text "of RUNNING job(s):" -font $LABELFONT



## ARRANGEMENT ON SCREEN
  pack  $dbox_top.m1
  pack  $dbox_top.r

  pack forget $msgFrame $checkboxFrame

  pack $dbox_top.header -side top
  pack $msgFrame -anchor nw -pady 6m -padx 14m -anchor nw
  pack $dbox_top.empty1 $dbox_top.checkboxLabel1 -side left -anchor nw

  $checkboxFrame configure -borderwidth 2 -relief groove

  pack $checkboxFrame $dbox_top.label2 $jobidFrame \
	-after $dbox_top.checkboxLabel1 -anchor nw \
	-side left
  pack $dbox_top.footer -before $msgFrame -side bottom


  register_default_action $qmsgDialogBox $cmdCancel
  tkwait visibility $qmsgDialogBox
  remove_busy_cursor
  catch {tkwait window $qmsgDialogBox}
  set activeWindow($qmsgDialogBox) 0
  catch {unset qmsgv}
}
